#include <stdio.h>
#include <stdlib.h>
#include "iocrema.h"

/* usato per la stampa parziale */
#define NUMVAL 10

int main()
{
  int *p;
  int i, N;

  StampaStringa("Dimensione del vettore: ");
  N = LeggeIntero();
  ACapo();

  p = (int *) calloc(N, sizeof(int));
  if (p != NULL)
    {
      for (i=0; i<N; i++)
	{
	  /* gli indici vanno da 0 a N-1, i valori da 1 a N */
	  p[i] = i+1;
	}

      /* stampa tutti gli elementi */
      /*
	for (i=0; i<N; i++)
	{
	StampaIntero(p[i]);
	StampaStringa(" ");
	}
	ACapo();
      */
      /* Stampa alternativa: visualizza solo NUMVAL elementi equidistribuiti */
      double step = (N<=NUMVAL ? 1 : (double)(N-1)/(NUMVAL-1));
      for (i=0; i<NUMVAL; i++)
	{
	  int istep = i*step;
	  if (istep < N) {
	    StampaIntero(p[istep]);
	    if (step > 1 && i < NUMVAL-1)
	      StampaStringa(" ... ");
	    StampaStringa(" ");
	  }
	}
      ACapo();
    }
  else
    {
      StampaStringa("ERRORE: Dimensione troppo grande");
      ACapo();
      return 1;
    }

  /* rilascia la memoria allocata */
  free(p);

  return 0;
}
